var done = false;

runScript("scripts/vector.js");

var camPos = new Vector(0,1,-2);
var playerPos = new Vector(0,0,0);
var playerVel = 0;
var playerLeft = true;
var playerUp = 0;
var playerCanJump = false;

var lives = 5;

var resetPos = 0;

var levelData = null;
var level = 0;

var gameState_load = 0;
var gameState_ready = 1;
var gameState_play = 2;
var gameState_fall = 3;
var gameState_goBack = 4;
var gameState_portal = 5;
var gameState_levelNum = 6;
var gameState_gameOver = 7;
var gameState_title = 8;

var gameState = gameState_load;
var gameTime = 0;

runScript("scripts/update.js");
runScript("scripts/draw.js");
runScript("scripts/particalEmiter.js");
runScript("scripts/track.js");
runScript("scripts/genLevel.js");
runScript("scripts/level.js");

var startTime = getTime();
while((!escDown()) && (!done))
{
	var time = getTime()-startTime;
	startTime += time;

	var oldGameState = gameState;
	update(time*4);

	clear();

	var newGameState = gameState;
	gameState = oldGameState;
	draw();
	gameState = newGameState;

	if(oldGameState != newGameState){
		gameTime = 0;
	}

	flip();
}