function Partical()
{
	this.life = 0;
	this.pos = new Vector(0,0,0);
	this.vel = new Vector(0,0,0);

	return this;
}

function drawParticals()
{
	set3DLineWidth(0.4);
	for(var i=0;i<this.nparts;i++){
		if(this.parts[i].life > 0){
			var l = this.parts[i].life;
			l=l*l*l*l;
			setColor(this.parts[i].life,l/2,(1-l)*l);
			
			draw3DPoint(this.parts[i].pos);
		}
	}
}

function ParticalEmiter(pos,center)
{
	this.center = center;
	this.nparts = particalsPerEmiter;
	this.parts = new Array(this.nparts);
	for(var i=0;i<this.nparts;i++){
		this.parts[i] = new Partical();
	}
	this.nextTime = Math.random();
	this.t = 0;
	this.pos = pos;

	this.update = function(time)
	{
		this.t += time;

		for(var i=0;i<this.nparts;i++){
			if(this.parts[i].life > 0){
				this.parts[i].pos.x += this.parts[i].vel.x*time*5/3;
				this.parts[i].pos.y += this.parts[i].vel.y*time;
				this.parts[i].pos.z += this.parts[i].vel.z*time;
				//this.parts[i].pos.y += this.parts[i].vel.y*time// + time*time*6.25/16;
				//this.parts[i].vel.y += time*12.5/16;
				this.parts[i].life -= time;
			}else if(this.nextTime <= 0){
				this.nextTime = Math.random()*(1/particalsPerEmiter);
				this.parts[i].life = 1;
				this.parts[i].pos = new Vector(this.pos.x,this.pos.y,this.pos.z);
				this.parts[i].vel = new Vector((Math.random()-0.5)/5,(Math.random()-0.5)/5,(Math.random()-0.5)/5);
			}
		}
		this.nextTime -= time;
	}

	this.draw = drawParticals;

	return this;
}